%%*******************************************************************
%% NTdirfun: compute (dX,dZ), given dy, for the NT direction.
%% 
%% SDPT3: version 3.0 
%% Copyright (c) 1997 by
%% K.C. Toh, M.J. Todd, R.H. Tutuncu
%% Last modified: 2 Feb 01
%%*******************************************************************

    function [dX,dy,dZ] = NTdirfun(blk,Avec,par,Rd,EinvRc,xx); 
    
    global W dd ee 
%%
    m = size(Avec{1},2); 
    dy = xx(1:m); 
    count = m; 
    dX = cell(size(blk,1),1); dZ = cell(size(blk,1),1); 
%%
    for p=1:size(blk,1)
       pblk = blk(p,:);  
       if strcmp(pblk{1},'l')
          dZ{p} = Rd{p} - Avec{p}*dy;     
          tmp   = dd{p}.*dZ{p};
          dX{p} = EinvRc{p} - tmp;
       elseif strcmp(pblk{1},'q')
          dZ{p} = Rd{p} - Avec{p}*dy;  
          tmp = dd{p}.*dZ{p} + qops(pblk,qops(pblk,dZ{p},ee{p},1),ee{p},3); 
          dX{p} = EinvRc{p} - tmp;       
       elseif strcmp(pblk{1},'s') 
          dZ{p} = Rd{p} - smat(pblk,Avec{p}*dy(par.permA(p,:)),par.isspAy(p)); 
          tmp   = Prod3(pblk,W{p},dZ{p},W{p},1); 
          dX{p} = EinvRc{p}-tmp;
       elseif strcmp(pblk{1},'u'); 
          n = sum(pblk{2}); 
          dZ{p} = zeros(n,1); 
          dX{p} = xx(count+[1:n]); 
          count = count + n;  
       end
    end      
%%*******************************************************************
