%%*******************************************************************
%% schurmat_qblk: 
%%
%% options = 0, HKM
%%         = 1, NT
%% 
%% SDPT3: version 3.0 
%% Copyright (c) 1997 by
%% K.C. Toh, M.J. Todd, R.H. Tutuncu
%% Last modified: 10 Jun 02
%%*******************************************************************

   function [schur,UU,VV] = schurmat_qblk(blk,Avec,schur,UU,VV,p,dd,ee,xx);
   
   if (nargin == 9); options = 0; else; options = 1; end; 
      
   pblk = blk(p,:); n = sum(pblk{2});  
   
   Ae = qprod(pblk,Avec{p}',ee{p}); 
   if (options == 0) 
      Ax = qprod(pblk,Avec{p}',xx{p}); 
   end; 
   [decolidx,spcolidx] = checkdense(Ae);
   ddsch = dd{p};    
   if ~isempty(decolidx); 
      s = 1 + [0 cumsum(pblk{2})];
      idx = s(decolidx); 
      tmp = zeros(n,1); 
      tmp(idx) = sqrt(2*abs(ddsch(idx))); 
      Ad = qprod(pblk,Avec{p}',tmp); 
      ddsch(idx) = abs(ddsch(idx)); 
      if (options == 0) 
         UU = [UU Ax(:,decolidx) Ae(:,decolidx)  Ad]; 
         VV = [VV Ae(:,decolidx) Ax(:,decolidx) -Ad]; 
         Ax = Ax(:,spcolidx); Ae = Ae(:,spcolidx); 
         schur = schur + Ax*Ae'+ Ae*Ax';         
      else
         UU = [UU Ae(:,decolidx)  Ad]; 
         VV = [VV Ae(:,decolidx) -Ad]; 
         Ae = Ae(:,spcolidx);      
         schur = schur + Ae*Ae';
      end
   else
      if (options == 0)
         schur = schur + Ax*Ae'+ Ae*Ax';
      else 
         schur = schur + Ae*Ae';
      end
   end
   [decolidx,spcolidx] = checkdense(Avec{p}'); 
   if ~isempty(decolidx); 
      len = length(decolidx);               
      tmp = (spdiags(sqrt(abs(ddsch(decolidx))),0,len,len)*Avec{p}(decolidx,:))'; 
      UU = [UU tmp]; 
      VV = [VV tmp*spdiags(sign(ddsch(decolidx)),0,len,len)]; 
      ddsch(decolidx) = zeros(len,1); 
   end  
   schur = schur + Avec{p}' *spdiags(ddsch,0,n,n) *Avec{p}; 
%%*******************************************************************
