function display(quiz)
% SDMPB/DISPLAY - Command window display of an SDMPB object

%   This file is part of SeDuMi Interface 1.04 (JUL2002)
%   last update 6th September 2002  
%   Copyright (C) 2002 Dimitri Peaucelle & Krysten Taitz
%   LAAS-CNRS, Toulouse, France
% 
%   This program is free software; you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation; either version 2 of the License, or
%   (at your option) any later version.
% 
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
% 
%   You should have received a copy of the GNU General Public License
%   along with this program; if not, write to the Free Software
%   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

  fprintf('\nLMC problem: %s\n\n',quiz.name);
  if quiz.var.nb
    fprintf('matrix variables:\t index \t\t name \n');
    for ii=1:quiz.var.nb
      fprintf('\t\t\t %i \t\t %s \n',ii,quiz.var.name{ii});
    end;
  else
    fprintf('no matrix variable\n');
  end;
  if quiz.eq.nb
    fprintf('equality constraints:\t index \t norm \t name \n');
    for ii=1:quiz.eq.nb
      if quiz.eq.M(ii)<quiz.eq.m(ii)
	mnorm=0;
      else
	mnorm=quiz.eq.mnorm{ii};
      end;
      fprintf('\t\t\t %i \t %s\t %s \n',ii,num2str(mnorm,1),quiz.eq.name{ii});
    end;
  else
    fprintf('no equality constraint\n');
  end;
  if quiz.ineq.nb
    fprintf('inequality constraints:\t index \t meig \t name \n');
    for ii=1:quiz.ineq.nb
      if quiz.ineq.M(ii)<quiz.ineq.m(ii)
	meig=0;
      else
	meig=quiz.ineq.meig{ii};
      end;
      fprintf('\t\t\t %i \t %s\t %s \n',ii,num2str(meig,1),quiz.ineq.name{ii});
    end;
  else
    fprintf('no inequality constraint\n');
  end;
  if isempty(quiz.obj.name)    
    fprintf('no linear objective\n');
  else
    fprintf('maximise objective:%s',quiz.obj.name);
    if ~isempty(quiz.obj.opt)
      fprintf(' = %.3g\n',quiz.obj.opt);
    else
      fprintf('\n');
    end;
  end;
  fprintf('%s\n\n',quiz.feas);

