function sdmdemo
% SDMDEMO - demonstration of SeDuMi Interface 1.04
%

%   This file is part of SeDuMi Interface 1.04 (JUL2002)
%   Last update : 23rd September 2002
%   Copyright (C) 2002 Dimitri Peaucelle & Krysten Taitz
%   LAAS-CNRS, Toulouse, France
% 
%   This program is free software; you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation; either version 2 of the License, or
%   (at your option) any later version.
% 
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
% 
%   You should have received a copy of the GNU General Public License
%   along with this program; if not, write to the Free Software
%   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

%#external
  header='Choose a demo';
  item1='example of the User''s guide';
  item2='a H2/Hinfinity state feedback example';
  item = menu(header,item1,item2);
  next = sprintf('%s',' -- type key to continue -- ');
  dotline = '------------------------------------------------------';
  switch item
   case 1
    clc
    fprintf(['This demo is conceived to help the reader of the user''s' ...
	     ' guide\n No comments are added to the matlab commands']);
    fprintf('\n%s',next);pause;fprintf('\r');
    clc
    fprintf('#####################################\n');  
    fprintf('# 2.1   # LMC problem: an sdmpb object\n');  
    fprintf('#####################################\n\n');  
    do = sprintf('quiz = sdmpb(''Optimal Hinfty State-Feedback Synthesis'')');
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    do = sprintf('whos quiz');
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    do = sprintf(['n=4; m=1; q=1; p=2;\n', ...
		  'A = [1 0 0 -1 ; 0 -1 1 0 ; -1 0 1 0 ; 0 -1 0 1 ];\n', ...
		  'Bu = [ 1 ; 0 ; 0 ; 0 ];\n', ...
		  'Bw = [ 0 ; 1 ; 0 ; 0 ];\n', ...
		  'Cz = [ 0 0 0 1 ; 1 0 0 1 ];\n', ...
		  'Dzu = [ 1 ; 0 ];\n']);
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    clc
    fprintf('#####################################\n');  
    fprintf('# 2.2   # Defining variables: sdmvar\n');  
    fprintf('#####################################\n\n');  
    do = sprintf(['[quiz, Yindex] = sdmvar(quiz, m, n, ''Y'');\n', ...
		  'quiz']);
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    do = sprintf(['[quiz, gindex] = sdmvar(quiz, 1, 1, ''gamma^2'');\n', ...
		  '[quiz, Qindex] = sdmvar(quiz, n, ''s'', ''Q'');\n', ...
		  'quiz']);
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    do = sprintf(['get(quiz, ''varnb'')']);
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    do = sprintf(['get(quiz, ''varname'', gindex)']);
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    do = sprintf(['get(quiz, ''vardec'', Qindex)']);
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    clc
    fprintf('###################################################\n');  
    fprintf('# 2.3   # Defining an inequality constraint: sdmlmi\n');  
    fprintf('###################################################\n\n');  
    do = sprintf(['[quiz, lmi1index] = sdmlmi( quiz,  [n], ''Q>0'');\n', ...
		  '[quiz, lmi2index] = sdmlmi(quiz, [n p], ''Hinfty state-feedback'');\n', ...
		  'quiz']);
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    do = 'get(quiz, ''ineqnb'')';
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    do = 'get(quiz, ''ineqname'', lmi2index)';
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf(['\r                            \n']);
    do = 'get(quiz, ''ineqdim'', lmi2index)';
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    clc
    fprintf('#########################################################\n');  
    fprintf('# 2.4   # Add a term to an inequality constraint: sdmineq\n');  
    fprintf('#########################################################\n\n');  
    do = sprintf(['L = Cz;\n', ...
		  'R = 1;\n', ... 
		  'quiz = sdmineq(quiz, [lmi2index 2 1], Qindex, L, R);       \n\n', ...
		  'L = Bw;\n', ...
		  'R = 0.5*L'';\n', ...
		  'quiz = sdmineq(quiz, [lmi2index 1 1], 0, L, R); \n\n', ...
		  'quiz = sdmineq(quiz, [lmi2index 1 1], Qindex,    A, 1);\n\n',...
		  'quiz = sdmineq(quiz, [lmi2index 1 1], Yindex,   Bu, 1);\n\n',...
		  'quiz = sdmineq(quiz, [lmi2index 2 1], Yindex,  Dzu, 1);\n\n',...
		  'quiz = sdmineq(quiz, [lmi2index 2 2], gindex, -0.5, 1);\n\n', ...		  
		  'quiz = sdmineq(quiz, [lmi1index 1 1], Qindex, -0.5, 1);']);
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    clc
    fprintf('####################################################\n');  
    fprintf('# 2.5   # Add a linear term to the objective: sdmobj\n');  
    fprintf('####################################################\n\n');  
    do = sprintf(['quiz = sdmobj(quiz, gindex, -1, 1, ''-gamma^2'');\n', ...
		  'quiz']);
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    do = 'get(quiz,''objname'')';
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    clc
    fprintf('#####################################\n');  
    fprintf('# 2.6   # Solve an LMC problem: sdmsol\n');  
    fprintf('#####################################\n\n');  
    do = sprintf(['quiz = sdmsol(quiz);']);
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    do = 'quiz';
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    do = 'get(quiz, ''feas'')';
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    clc
    fprintf('##########################################\n');  
    fprintf('# 2.7   # Extracting the computed solution\n');  
    fprintf('##########################################\n\n');  
    do = sprintf(['g2_opt = get(quiz, ''varvalue'', gindex)']);
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    do = 'Y_opt = quiz(Yindex)';
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    do = 'get(quiz,''objopt'')';
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    clc
    fprintf('###########################################\n');  
    fprintf('# 2.8   # Analysis of the computed solution\n');  
    fprintf('###########################################\n\n');  
    do = 'get(quiz, ''ineqmeig'', lmi1index)';
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    do = 'quiz';
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    clc
    fprintf('######################################\n');  
    fprintf('# 3.1   # Structured variables: sdmvar\n');  
    fprintf('######################################\n\n');  
    do = sprintf(['[quiz, Dindex] = sdmvar(quiz, 3i, ''d'', ''D : diagonal'');\n',...
		 'num2str(quiz{Dindex})']);
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    do = sprintf(['[quiz, Gindex] = sdmvar(quiz, 3, ''as'', ''G'');\n',...
		  'quiz{Gindex}']);
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    do = sprintf(['[quiz, Hindex] = sdmvar(quiz, 2i, ''h'', ''H'');\n',...
		  'num2str(quiz{Hindex})']);
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    do = sprintf(['[quiz, Jindex] = sdmvar(quiz, 3i, ''ah'', ''J'');\n',...
		  'num2str(quiz{Jindex})']);
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    do = sprintf(['Ddec = quiz{Dindex};\n',...
		  'Ddecbar = conj(Ddec);\n',...
		  'Gdec = quiz{Gindex};\n',...
		  'Fdec = [ Ddecbar , Gdec ];\n',...
		  '[quiz, Findex] = sdmvar(quiz, Fdec, ''st'', ''[D, G]'');\n',...
		  'num2str(quiz{Findex})']);
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    do = sprintf(['get(quiz, ''vardecnb'')']);
    fprintf('%s\n',do);eval(do);
    do = sprintf(['Kdec = [28+28i 0 -28-28i;30+30i 29 30-30i];\n',...
		  '[quiz, Kindex] = sdmvar(quiz, Kdec, ''st'', ''K'');\n',...
		  'num2str(quiz{Kindex})']);
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    clc
    fprintf('#################################################\n');  
    fprintf('# 3.3.1 # Defining an equality constraint: sdmlme\n');  
    fprintf('#################################################\n\n');  
    do = sprintf(['[quiz, lmeindex] = sdmlme(quiz, [2 1], [3 1], ''[K 0;0 Q11]=[H 0;0 conj(D11)-1+i]'');\n',...
		 'quiz']);
    fprintf('%s\n',do);eval(do);
    do = 'get(quiz, ''eqnb'')';
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    fprintf('%s\n',do);eval(do);
    do = 'get(quiz, ''eqdimrow'', lmeindex)';
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    do = 'get(quiz, ''eqdimcol'', lmeindex)';
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    do = 'get(quiz, ''eqname'', lmeindex)';
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    clc
    fprintf('#####################################################\n');  
    fprintf('# 3.3.2 # Add a term to an equality constraint: sdmeq\n');  
    fprintf('#####################################################\n\n');  
    do = sprintf(['%%   ADVANCED USAGE USED AT THIS STEP\n\n',...
		  'quiz = sdmeq(quiz, [ lmeindex 1 1],   Kindex);\n',...
		  'quiz = sdmeq(quiz, [-lmeindex 1 1],   Hindex,         1,  [i i 0 ; 0 0 1]);\n',...
		  'quiz = sdmeq(quiz, [-lmeindex 1 1],        0,         1, [2i i 0 ; 0 0 0]);\n',...
		  'quiz = sdmeq(quiz, [ lmeindex 2 2],   Qindex, [1 0 0 0]);\n',...
		  'quiz = sdmeq(quiz, [ lmeindex 2 2],        0,        -1,              1-i);\n',...
		  'quiz = sdmeq(quiz, [-lmeindex 2 2], i*Dindex,   [1 0 0]);']);
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    do = sprintf(['quiz = sdmsol(quiz)']);
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    do = sprintf(['get(quiz, ''eqnorm'', lmeindex)\n',...
		  'K_opt = quiz(Kindex)']);
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    clc
    fprintf('##############################################\n');  
    fprintf('# 3.5   # Set a value to some variable: sdmset\n');  
    fprintf('##############################################\n\n');  
    do = sprintf(['quiz = sdmset(quiz, gindex, 30);\n',...
		  'quiz = sdmsol(quiz);']);
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    do = 'quiz';
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    do = 'quiz(gindex)';
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    do = sprintf(['quiz = sdmset(quiz, Gindex, [0 -1 1 ; 1 0 2 ; -1 -2 0]);\n',...
		  'quiz{Gindex}']);
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
    do = 'num2str(quiz{Findex})';
    fprintf('%s\n',do);eval(do);
    fprintf('\n%s',next);pause;fprintf('\r                                      \n');
   case 2
    next1= 'fprintf(''%s\n'',write);fprintf(''\n%s'',next);pause;';
    next2 = 'clc;fprintf(''%s\n\n'',dotline);fprintf(''%s\n'',write);fprintf(''%s\n\n'',dotline);';

    clc;fprintf('%s\n\n',dotline);

    write=sprintf(['Consider the following LTI system \n\n',...
		   '\t dx/dt = A .x + B1.w1 + B2.w2 + B .u\n',...
		   '\t   z1  = C1.x + D1.w1         + E1.u\n',...
		   '\t   z2  = C2.x                 + E2.u\n\n',...
		   'with the following dimensions: \n\n',...
		   '   - n  = size(x ) , q1 = size(w1) , q2 = size(w2) , m  = size(u)\n',...
		   '   - p1 = size(z1)\n',...
		   '   - p2 = size(z2)\n\n',...
		   'For the demo a random example is generated\n',...
		   'choose the size in thne ui menu\n\n']);
    fprintf('%s\n',write);
    headerr='Choose the size of the system';
    itemm1='n=3 ; q1=2 ; q2=1 ; m=1 ; p1=1 ; p2=2; (small size)';
    itemm2='n=10 ; q1=2 ; q2=2 ; m=3 ; p1=2 ; p2=4; (medium size)';
    itemm3='n=30 ; q1=4 ; q2=3 ; m=4 ; p1=2 ; p2=4; (large size)';
    itemm = menu(headerr,itemm1,itemm2,itemm3);    
    switch itemm
     case 1
      n=3 ; q1=2 ; q2=1 ; m=1 ; p1=1 ; p2=2;
     case 2
      n=10 ; q1=2 ; q2=2 ; m=3 ; p1=2 ; p2=4;
     case 3
      n=30 ; q1=4 ; q2=3 ; m=4 ; p1=2 ; p2=4;
    end;
    A =sprand(n,n,1)-speye(n);
    B1=sprand(n,q1,1);
    B2=sprand(n,q2,1);
    B =sprand(n,m ,1);
    C1=sprand(p1,n,1);
    D1=sprand(p1,q1,1);
    E1=sprand(p1,m,1);
    C2=sprand(p2,n,1);
    E2=sprand(p2,m,1);

    eval(next2);
    
    write = sprintf(['Solve the H2/Hinfty state-feedback synthesis problem\n',...
		     'such that u=K.x guarantees for the closed loop:\n\n',...
		     '  (1) Hinfty norm of the transfer w1 -> z1 minimized and less than G1=10\n',...
		     '  (2) H2     norm of the transfer w2 -> z2 minimized \n\n']);
    G1=10;

    eval(next1);eval(next2);
    
    write = sprintf(['An LMI-based formulation of this problem writes for example as:\n\n',...
		     '  - variables :',...
		     '\n\t X ( n  x n  ) symmetric',...
		     '\n\t T ( p2 x p2 ) symmetric',...
		     '\n\t S ( m  x n  )',...
		     '\n\t g   scalar\n\n',...
		     '  - constraints :\n\n',...
		     '\t 0 < X\n\n',...
		     '\t [ A*X+X*A''+B*S+B''*S''+B1*B1 , X*C1''+S''*E1''+B1*D1'' ]\n',...
		     '\t [ C1*X+E1*S+D1*B1''         , -g*I+D1*D1''         ] < 0\n\n',...
		     '\t A*X+X*A''+B*S+S''*B''+B2*B2'' < 0\n\n',...
		     '\t [ -T           , C2*X+E2*S ]\n',...
		     '\t [ X*C2''+S''*E2'' , -X        ] < 0\n\n',...
		     '\t gamma < G1^2\n\n',...
		     '  - objective :\n\n',...
		     '\t G2^2 = min trace(T) + g \n\n']);
 
    eval(next1);eval(next2);
       
    write = sprintf(['For SeDuMi Interface the constraints are for example rewritten as:\n\n',...
		     '\t 0 < X\n\n',...
		     '\t He{ [  A*X+ B*S ,  0 ] } + [ B1 ]*[ B1 ]'' < [ 0 ,   0 ]\n',...
		     '\t   { [ C1*X+E1*S ,  0 ] }   [ D1 ] [ D1 ]    [ 0 , g*I ] \n\n',...
		     '\t He{ A*X+B*S } + B2*B2'' < 0\n\n',...
		     '\t He{ [ 0 , C2*X+E2*S ] } < [ T , 0 ]\n',...
		     '\t   { [ 0 ,         0 ] }   [ 0 , X ]\n\n',...
		     '\t g < G1^2 \n\n']);
    
    eval(next1);eval(next2);
    
    write1 = sprintf(['The optimization problem is declared with SeDuMi Interface as follows\n\n',...
		     'INITIALIZE PROBLEM \n\n',...
		     '  >> quiz = sdmpb(''H2/Hinfty state-feedback synthesis'');\n\n']);
    write2 = sprintf(['DECLARE VARIABLES\n\n',...
		      '  >> [quiz,Xindex] = sdmvar(quiz, n,  ''s'', ''X'');\n',...
		      '  >> [quiz,Tindex] = sdmvar(quiz, p2, ''s'', ''T'');\n',...
		      '  >> [quiz,Sindex] = sdmvar(quiz, m,  n,   ''S'');\n',...
		      '  >> [quiz,gindex] = sdmvar(quiz, 1,  1,   ''g'');\n\n']);
    write3 = sprintf(['DECLARE CONSTRAINTS\n\n',...
		      '  >> [quiz,c1] = sdmlmi(quiz, n, ''X>0'');\n',...
		      '  >> quiz = sdmineq(quiz, -c1     , Xindex);\n',...
		      '  >> [quiz,c2] = sdmlmi(quiz, [n p1], ''Hinf'');\n',...
		      '  >> quiz = sdmineq(quiz, [c2 1 1], Xindex,       A, 1);\n',...
		      '  >> quiz = sdmineq(quiz, [c2 1 1], Sindex,       B, 1);\n',...
		      '  >> quiz = sdmineq(quiz, [c2 2 1], Xindex,      C1, 1);\n',...
		      '  >> quiz = sdmineq(quiz, [c2 2 1], Sindex,      E1, 1);\n',...
		      '  >> quiz = sdmineq(quiz,  c2     , 0     , [B1;D1]);\n',...
		      '  >> quiz = sdmineq(quiz,[-c2 2 2], gindex);\n',...
		      '  >> [quiz,c3] = sdmlmi(quiz,n,''gram'');\n',...
		      '  >> quiz = sdmineq(quiz,  c3     , Xindex,       A, 1);\n',...
		      '  >> quiz = sdmineq(quiz,  c3     , Sindex,       B, 1);\n',...
		      '  >> quiz = sdmineq(quiz,  c3     , 0     ,      B2);\n']);
    write4 = sprintf(['  >> [quiz,c4] = sdmlmi(quiz, [p2 n],''H2'');\n',...
		      '  >> quiz = sdmineq(quiz, [c4 1 2], Xindex,      C2, 1);\n',...
		      '  >> quiz = sdmineq(quiz, [c4 1 2], Sindex,      E2, 1);\n',...
		      '  >> quiz = sdmineq(quiz,[-c4 1 1], Tindex);\n',...
		      '  >> quiz = sdmineq(quiz,[-c4 2 2], Xindex);\n',...
		      '  >> [quiz,c5] = sdmlmi(quiz,1,''g<G1^2'');\n',...
		      '  >> quiz = sdmineq(quiz,  c5     , gindex);\n',...
		      '  >> quiz = sdmineq(quiz, -c5     , 0     ,      G1);\n\n']);
    write5 = sprintf(['\nDECLARE OBJECTIVE (maximization)\n\n',...
		      '  >> quiz = sdmobj(quiz,Tindex,''tr'',-1,''-trace(T)'')\n',...
		      '  >> quiz = sdmobj(quiz,gindex,-1,1,''-g'')\n\n']);
    write=[write1,write2,write3,write4,write5];
		      
    fprintf('%s',write1);
    quiz = sdmpb('H2/Hinfty state-feedback synthesis');
    fprintf('%s',write2);
    [quiz,Xindex] = sdmvar(quiz,n,'s','X');
    [quiz,Tindex] = sdmvar(quiz,p2,'s','T');
    [quiz,Sindex] = sdmvar(quiz,m,n,'S');
    [quiz,gindex] = sdmvar(quiz,1,1,'g');
    fprintf('%s',write3);
    [quiz,c1] = sdmlmi(quiz,n,'X>0');
    quiz = sdmineq(quiz,-c1,Xindex);    
    [quiz,c2] = sdmlmi(quiz,[n p1],'Hinf');
    quiz = sdmineq(quiz, [c2 1 1], Xindex,       A, 1);
    quiz = sdmineq(quiz, [c2 1 1], Sindex,       B, 1);
    quiz = sdmineq(quiz, [c2 2 1], Xindex,      C1, 1);
    quiz = sdmineq(quiz, [c2 2 1], Sindex,      E1, 1);
    quiz = sdmineq(quiz,  c2     , 0     , [B1;D1]);
    quiz = sdmineq(quiz,[-c2 2 2], gindex);    
    [quiz,c3] = sdmlmi(quiz,n,'gram');
    quiz = sdmineq(quiz, c3,Xindex,A,1);
    quiz = sdmineq(quiz, c3,Sindex,B,1);
    quiz = sdmineq(quiz, c3,0     ,B2);
    fprintf('%s',write4);
    [quiz,c4] = sdmlmi(quiz, [p2 n],'H2');
    quiz = sdmineq(quiz, [c4 1 2], Xindex, C2, 1);
    quiz = sdmineq(quiz, [c4 1 2], Sindex, E2, 1);
    quiz = sdmineq(quiz,[-c4 1 1], Tindex);
    quiz = sdmineq(quiz,[-c4 2 2], Xindex);    
    [quiz,c5] = sdmlmi(quiz,1,'g<G1^2');
    quiz = sdmineq(quiz, c5,gindex);
    quiz = sdmineq(quiz,-c5,0     ,G1);
    fprintf('%s\n',write5);
    quiz = sdmobj(quiz,Tindex,'tr',-1,'-trace(T)');
    quiz = sdmobj(quiz,gindex,-1,1,'-g');
    
    fprintf('\n%s',next);pause;eval(next2);
    
    write1 = sprintf(['For details on every sdm*** function type ''help sdm***''\n\n',...
		     'Note that at each step it is possible ',...
		     'to have some information on the problem:\n\n',...
		     '>> quiz']);
    write2 = sprintf(['It gives the name of the optimization problem,\n',...
		      'the number of matrix variables, their names and indexes,\n',...
		      'the number of inequality constraints, their names and indexes,\n',...
		      'the name of the linear objective.\n',...
		      'Moreover it is possible to get the structure of any matrix variable\n',...
		      'by giving its index as in:\n',...
		      '>> quiz{Tindex}']);
    fprintf('%s\n',write1);
    quiz
    fprintf('%s\n',write2);
    quiz{Tindex}
    lT=size(quiz{Tindex},1);
    write3 = sprintf(['here T is a symmetric variable depending on %i decision variables\n',...
		      'numbered from %i to %i\n\n'],lT*(lT+1)/2,min(min(quiz{Tindex})),max(max(quiz{Tindex})));
    fprintf('%s\n',write3);

    fprintf('\n%s',next);pause;
    clc;fprintf('%s\n\n',dotline);
    fprintf('%s\n',write1);
    quiz
    fprintf('%s\n',write2);
    quiz{Tindex}
    fprintf('%s\n',write3);
    fprintf('%s\n\n',dotline);
        
    fprintf('To solve this problem with SeDuMi:\n\n');
    fprintf('>> quiz = sdmsol(quiz);\n\n');
    quiz=sdmsol(quiz);  
    fprintf('The variable <quiz> is appended and contains the solution\n\n');

    fprintf('\n%s',next);pause;
    fprintf('\r%s\n\n',dotline);

    write1 = sprintf(['The obtained solution is the optimal point if the algorithm succeeded\n\n',...
		      '>> quiz']);
    write2 = sprintf(['the display of the variable quiz (SDMPB object)\n',...
		      'informs on the status of the optimization problem.\n',...
		      'It gives for each inequality constraint the minimal eigenvalue\n',...
		      '(the constraint is exactly satisfied if meig>=0)\n',...
		      '(if meig=-eps or +eps then close to zero at the accuracy level)\n',...
		      'and the optimal objective value\n\n']);
    fprintf('%s\n',write1);
    quiz
    fprintf('%s\n',write2);
    
    fprintf('\n%s',next);pause;
    clc;fprintf('%s\n\n',dotline);
    fprintf('%s\n',write1);
    quiz
    fprintf('%s\n',write2);
    fprintf('%s\n\n',dotline);
    
    write1 = sprintf(['Moreover the values of the variables for the obtained point\n',...
		      'are easily obtained: \n\n',...
		      '>> Sopt=quiz(Sindex)']);
    write2 = sprintf(['contains the optimal value of S \n\n',...
		      '>> Topt=quiz(Tindex);\n',...
		      '>> sqrt(trace(Topt)))']);
    write3 = sprintf(['gives the guaranteed H2 norm (sqrt(trace(T)))\n\n',...
		      '>> gopt=quiz(gindex)\n',...
		      '>> sqrt(gopt)']);
    write4 = sprintf('gives the guaranteed Hinfty norm (sqrt(g))\n\n');

    fprintf('%s\n',write1);
    Sopt=quiz(Sindex)
    fprintf('%s\n',write2);
    sqrt(trace(quiz(Tindex)))
    fprintf('%s\n',write2);
    sqrt(quiz(gindex))
    fprintf('%s\n',write4);
    
    fprintf('\n%s',next);pause;
    clc;fprintf('%s\n\n',dotline);
    fprintf('%s\n',write1);
    Sopt=quiz(Sindex)
    fprintf('%s\n',write2);
    sqrt(trace(quiz(Tindex)))
    fprintf('%s\n',write2);
    sqrt(quiz(gindex))
    fprintf('%s\n',write4);
    fprintf('%s\n\n',dotline);
    
    write = sprintf(['Consider that the H2/Hinfty problem is modified such that:\n\n',...
		     'the minimization of the variable g is suppressed.\n\n',...
		     'One way to change the problem is to set in the LMIs: g=G1^2\n\n',...
		     '  >> quiz = sdmset(quiz,gindex,G1^2)\n\n']);
    quiz = sdmset(quiz,gindex,G1^2)
    
    eval(next1);eval(next2);
    
    write = sprintf(['The new problem can then be solved.\n\n',...
		     '>> quiz = sdmsol(quiz);\n\n']);
    fprintf('%s\n',write);
    quiz=sdmsol(quiz);  

    fprintf('\n%s',next);pause;
    fprintf('\r%s\n\n',dotline);
    
    fprintf('The obtained solution is the optimal point if the algorithm succeeded\n\n');
    fprintf('>> quiz');
    quiz
    fprintf('>> Topt=quiz(Tindex);\n');
    fprintf('>> sqrt(trace(Topt)))');
    sqrt(trace(quiz(Tindex)))
    fprintf('gives the guaranteed H2 norm (sqrt(trace(T)))\n\n');
    
  end;
  fprintf('\n\n -- end of demo - thanks -- \n\n');
  
  
  
  

  
  
  
  
  
  
