function x = sdmvec(X)
% SDMVEC - same as VEC but produces a sparse vector.
%  
% y = sdmvec(X) 
%  
%   Given an m x n matrix X, this produces the sparse vector y of length
%   m*n that contains the columns of the matrix X, stacked below each other.
%
% SEE ALSO vec, mat and sdmmat.

%   This file is part of SeDuMi Interface 1.04 (JUL2002)
%   Last update : 9th September 2002
%   Copyright (C) 2002 Dimitri Peaucelle & Krysten Taitz
%   LAAS-CNRS, Toulouse, France
% 
%   This program is free software; you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation; either version 2 of the License, or
%   (at your option) any later version.
% 
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
% 
%   You should have received a copy of the GNU General Public License
%   along with this program; if not, write to the Free Software
%   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

[m n] = size(X);
x = reshape(X,m*n,1);
