function y=min(varargin)
%MIN (overloaded)
%
% t = min(x,y,z...) % Scalar arguments 
% t = min(X)        % Matrix arguments, see built-in min for details  
%
% Creates an internal structure relating the variable t
% with the concave operator min(x,y,z,...)
%
% The variable t can only be used in convexity preserving
% operations such as t>0, max t etc.

% Author Johan Lfberg 
% $Id: min.m,v 1.5 2005/01/05 10:05:03 johanl Exp $

if nargin==1
    X = varargin{1};
    if min(size(X))==1
        if max(size(X))==1
            y = varargin{1};
        else
            %for i = 1:length(X)
            %    inparg{i} = subsref(X,struct('type','()','subs',{{i}}));
            %end
            inparg{1} = X;
            y = yalmip('addextendedvariable','min',inparg{:});
        end
    else
        y = [];
        for i = 1:size(X,2)
            clear inparg;
            for j = 1:size(X,1)
                inparg{j} = subsref(X,struct('type','()','subs',{{j,i}}));
            end
            y = [y yalmip('addextendedvariable','min',inparg{:})];            
        end
    end   
else
    y = yalmip('addextendedvariable','min',varargin{:});
end