function x = integer(x)
%PARAMETRIC Defines a variable as parametric
%
%   F = PARAMETRIC(x) is used to describe the set of
%   parametric variables in a multi-parametric program
%
%
%   INPUT
%    x : SDPVAR object
%
%   OUTPUT
%    F : SET object
%
%   EXAMPLE
%    F = set(prametric(x));           % Full verbose notation
%    F = parametric(x);               % Short notation
%
%   See also PARVAR, SDPVAR, SOLVESDP

% Author Johan Lfberg
% $Id: parametric.m,v 1.2 2004/07/09 14:29:38 johanl Exp $

x.typeflag = 13;
x = lmi(x);