function y = power(x,d)
%POWER (overloaded)

% Author Johan Lfberg 
% $Id: power.m,v 1.4 2004/12/21 17:01:42 johanl Exp $   

% Trivial cases
if d==0
    if x.n~=x.m
        error('Matrix must be square.')
    end
    y = eye(x.n,x.m).^0;
    return
end
if d==1
    y = x;
    return
end

% Fractional and negative powers 
if (ceil(d)-d>0) | (d<0)
    if x.n>1 | x.m>1
        error('Only scalars can have negative or non-integer powers');
    else
        base = getbase(x);
        if isequal(base,[0 1])
            mt = yalmip('monomtable');
            var = getvariables(x);
            previous_var = find((mt(:,var)==d)  & (sum(mt~=0,2)==1));
            if isempty(previous_var)
                mt(end+1,:) = mt(getvariables(x),:)*d;
                yalmip('setmonomtable',mt);
                y = recover(size(mt,1));
            else
                y = recover(previous_var);
            end
        else
            error('Only unit scalars can have negative or non-integer powers');
        end
    end
    return
end


if x.n>1 | x.m>1
    switch d
        case 0
            y = 1;
        case 1
            y = x;
        otherwise
            y = x.*power(x,d-1);
    end
else
    base = getbase(x);
    if isequal(base,[0 1])
        mt = yalmip('monomtable');
        var = getvariables(x);
        previous_var = find((mt(:,var)==d)  & (sum(mt~=0,2)==1));
        if isempty(previous_var)
            mt(end+1,:) = mt(getvariables(x),:)*d;
            yalmip('setmonomtable',mt);
            y = x;
            y.lmi_variables = size(mt,1);
            %y = recover(size(mt,1));
        else
            y = x;
            y.lmi_variables = previous_var;
            %y = recover(previous_var);
        end
    else
        switch d
            case 0
                y = 1;
            case 1
                y = x;
            otherwise
                y = x.*power(x,d-1);
        end
    end
end















return
if (ceil(d)-d>0) | (d<0)
    if x.n>1 | x.m>1
        error('Only scalars can have negative or non-integer powers');
    else
        base = getbase(x);
        if isequal(base,[0 1])
            mt = yalmip('monomtable');
            var = getvariables(x);
            previous_var = find((mt(:,var)==d)  & (sum(mt~=0,2)==1));
            if isempty(previous_var)
                mt(end+1,:) = mt(getvariables(x),:)*d;
                yalmip('setmonomtable',mt);
                y = recover(size(mt,1));
            else
                y = recover(previous_var);
            end
        else
            error('Only unit scalars can have negative or non-integer powers');            
        end
    end
    return
end

switch d
    case 0
        y = 1;
    case 1
        y = x;
    otherwise
        y = x.*power(x,d-1);     
end
