function monom = recovermonoms(newton_m,x);
%RECOVERMONOMS Internal function used in SOS programs

% Author Johan Lfberg
% $Id: recovermonoms.m,v 1.4 2004/10/14 12:58:06 johanl Exp $


mt = yalmip('monomtable');

vars = x.lmi_variables;

if size(newton_m,1)==1 & nnz(newton_m)==0
    monom = 1;
    return
end

%if nnz(newton_m(1,:)) == 0
%    append_one = 1;
%    newton_m = newton_m(2:end,:);
%else
%    append_one = 0;
%end

newton_m_extended = spalloc(size(newton_m,1),size(mt,2),nnz(newton_m));
newton_m_extended(:,vars) = newton_m;

hash = randn(size(mt,2),1);

mt_hash = mt*hash;
newton_m_extended_hash = newton_m_extended*hash;

monom = x;
monom.n = size(newton_m,1);
monom.m = 1;
monom.lmi_variables = [];
variable_here = ones(1,size(newton_m,1));
for i = 1:size(newton_m,1)
    if nnz(newton_m(i,:))==0
        variable_here(i) = 0;
    else
        previous_variable = find(abs(mt_hash - newton_m_extended_hash(i))<eps);
        if isempty(previous_variable)
            mt = [mt;newton_m_extended(i,:)];
            mt_hash = [mt_hash;newton_m_extended(i,:)*hash];
            monom.lmi_variables = [monom.lmi_variables size(mt,1)];
        else
            monom.lmi_variables = [monom.lmi_variables previous_variable];
        end
    end
end

% if append_one    
%     monom.basis = [[1;spalloc(monom.n,1,0)] [spalloc(1,monom.n,0);speye(monom.n)]];
%     monom.n = monom.n + 1;
% else
monom.basis = [spalloc(monom.n,1,0) spalloc(monom.n,length(find(variable_here)),0)];
monom.basis(find(variable_here),2:end) = speye(length(find(variable_here)));
monom.basis(find(variable_here==0),1)=1;
%end

% Fucked up order
if any(diff(monom.lmi_variables)<0)
    [i,j]=sort(monom.lmi_variables);
    monom.lmi_variables = monom.lmi_variables(j);
    monom.basis(:,2:end) = monom.basis(:,j+1);
end

[un_monom_vars,hh,jj] = unique(monom.lmi_variables);
if length(monom.lmi_variables) ~=length(un_monom_vars)
    newmonombase = monom.basis*sparse([1 1+jj],[1 1+(1:length(jj))],ones(1,1+length(jj)))';
    monom.basis = newmonombase;
    monom.lmi_variables = un_monom_vars;
end

yalmip('setmonomtable',mt);


% precalc = [];
% monom = [];
% for i = 1:size(newton_m,2)
%     powers = unique(newton_m(:,i));
%     for j = 1:length(powers)         
%         precalc{1+powers(j),i} = x(i)^powers(j);
%     end   
% end
% 
% monom = [];
% for i = 1:size(newton_m,1)
%     temp = 1;
%     for j = 1:size(newton_m,2)
%         temp = temp*precalc{newton_m(i,j)+1,j};%x(j)^newton_m(i,j);
%     end
%     monom = [monom;temp];
% end