function Y=sdpvarfun(varargin)
%SDPVARFUN Applies operator on matrix variable
%
% Y = sdpvarfun('op',X)  Applies the Matlab operator 'op' on X
%
% Example : Y = sdpvarfun('triu',X)  Extracts upper triangluar part

% Author Johan Lfberg 
% $Id: sdpvarfun.m,v 1.2 2004/07/01 11:17:13 johanl Exp $  

op = varargin{1};
if ~isa(op,'char')
  error('First argument must be a string with the function name')
end

X = varargin{2};
Y = X;

x_lmi_variables = X.lmi_variables;
lmi_variables = [];

Y.basis = [];
opX = feval(op,reshape(X.basis(:,1),X.n,X.m));
Y.basis = opX(:);

j = 1;
for i = 1:length(x_lmi_variables)
  opX = feval(op,reshape(X.basis(:,i+1),X.n,X.m));
  if (norm(opX,inf)>0)
    Y.basis(:,j+1) = opX(:);
    lmi_variables = [lmi_variables x_lmi_variables(i)];
    j = j+1;
  end
end  
Y.n = size(opX,1);
Y.m = size(opX,2);
Y.lmi_variables = lmi_variables;
