yalmip('clear')
clc
echo on
%*********************************************************
%
% Multi-parametric programing
%
%*********************************************************
%
% This example requires the MPT-Toolbox
%
% We return to the MPC-problem. 
% This time however, we seek the explicit solution as a 
% function of the current state x
pause

% Create numerics for a discretized double integrator
N = 5;
A = [2 -1;1 0];
B = [1;0];
C = [0.5 0.5];
[H,S] = create_CHS(A,B,C,N);
pause

% Variables
x = sdpvar(2,1);
U = sdpvar(N,1);
pause

% Parameterized predictions
Y = H*x+S*U; 

%Control constraints
F = set(-1 < U < 1);

% Terminal constraint
F = F+set(-1 < Y(N) < 1); 
pause

% Exploration space
F = F + set(-5 < x < 5);
pause

% Call solvemp (same syntax as solvesdp, except additional 
% fourth argument to specify the parametric variable)
mpsol = solvemp(F,Y'*Y+U'*U,[],x);
pause

% We can, e.g., plot the solution
plot(mpsol.Pn)

pause
echo off
