function F = lmi(X,handlestring)
% The command lmi is obsolete, see help sdpvar/set

% Author Johan Lfberg
% $Id: lmi.m,v 1.7 2005/01/04 11:16:30 johanl Exp $

%superiorto('sdpvar')

fast = 0;
switch nargin
    case 0
        F.clauses={};
        F.savedata = [];
        F = class(F,'lmi');
        return
    case 1
        handlestring = '';
        % ok probably, check later
    case 2
        if ~isa(handlestring,'char')
            error('The handle must be a string')
        end

    otherwise
        error('Wrong number of arguments')
end

F.clauses={};
F.savedata = [];

try
    F = class(F,'lmi');
catch
    disp('Failure in creating SET object. Restart MATLAB and try again, or type clear classes')
end

% Return empty LMI in degenerate case
if isempty(X)
    return
end

% 0 : Nothing (i.e error)
% 1 : LMI
% 2 : Elementwise
% 3 : Equality
% 4 : SOCC 
% 5 : Rotated Lorentz
% 9 : KYP constraint
%10 : Eigenvalue constraint
%11 : Sum of square constraint
%12 : Logic CNF
switch class(X)
case 'lmi'
    F = X;
    return
case 'char'
    try
        % Parse (check for old notation, take care of ||...|| notation)
        sdpvarExpr = parseLMI(X);
        % Old notation
        X = strrep(X,'.>','>');
        X = strrep(X,'.<','<');
     %   X = strrep(X,'=','==');X = strrep(X,'====','==');
    catch
        error(lasterr)
    end
    % Evaluate
    try
        Fi=evalin('caller',sdpvarExpr);
        switch class(Fi)
        case 'sdpvar'
            Fi = {Fi};
            strict = 0;
        case 'constraint'
            [Fi,strict] = getlist(Fi);            
        otherwise
        %if ~isa(Fi{1},'sdpvar')
            error('The string does not define an SDPVAR object')
        end
        
    catch
        error(lasterr)
    end
    
case 'sdpvar'
    Fi = {X};
    strict = 0;
    X='Numeric value';
    
case 'logic'
    Fi = {X};
    strict = 0;
    X = 'Numeric value';
    
case 'constraint'
    [Fi,strict] = getlist(X);    
    X='Numeric value';
    
otherwise
    error('The first argument should be an sdpvar object or string.')
end

% Return empty LMI in degenerate case
if all(cellfun('isempty',Fi))
    return
end

i = 1;
while i <= length(Fi)
    thisFi = Fi{i};
    if ~isempty(thisFi)
        if isa(thisFi,'logic')
            TypeofConstraint = 12;
        else
            TypeofConstraint = gethackflag(Fi{i});
        end
        % User just sent a sdpvar object, interpret as X>0
        if (TypeofConstraint==0)
            TypeofConstraint = 1;
        end
        
        if (TypeofConstraint==1)
            [n,m]=size(thisFi);
            if (n~=m)| ((TypeofConstraint == 1) & (n*m==1)) | ~ishermitian(thisFi) 
                TypeofConstraint = 2;
            end
        end
        
        switch TypeofConstraint
        case {1,2,3,4,5,7,8,9,10,11,12,13}
            F.clauses{i}{1}.data=thisFi;
            F.clauses{i}{1}.type = TypeofConstraint;
            F.clauses{i}{1}.symbolic=X;
            F.clauses{i}{1}.handle=handlestring;
            F.clauses{i}{1}.LMIid = yalmip('LMIid'); 
            F.clauses{i}{1}.strict = strict(i);
            F.clauses{i}{1}.cut = 0;
            i = i + 1;
        otherwise
            error('Error in argument in LMI. Please report bug');
        end
    end
    
end