function sys = plus(X,Y)
%PLUS Merges two LMI objects to one LMI

% Author Johan Lfberg
% $Id: plus.m,v 1.4 2005/01/04 17:00:26 johanl Exp $

if ~((isa(X,'lmi')) & (isa(Y,'lmi')))
    error('Both arguments must be SET objects')
end


nX = size(X.clauses,2);
nY = size(Y.clauses,2);
sys = X;
for i = 1:nY;
    for j = 1:size(Y.clauses{i},2)
        sys.clauses{i+nX}{j} = Y.clauses{i}{j};
    end
end

idX = getlmiid(sys);
% VERY FAST UNIQUE BECAUSE THIS IS CALLED A LOT OF TIMES....
i = sort(idX(:)');
i = i(diff([i NaN])~=0); 
if length(i)<nX+nY    
    [i,j] = unique(idX);
    sys = subsref(sys,struct('type','()','subs',{{j}}));
end
