function F = projection(F,x,method)
% REDUCE  Removes redundant constraints using MPT
%
% Freduced  = reduce(F)
%
% F  :  Polytopic SET object
%
% See also POLYTOPE, PROJECTION

% Author Johan Lfberg
% $Id: reduce.m,v 1.2 2004/12/08 18:55:01 johanl Exp $

f = [];
for i = 1:length(F)
    if  F.clauses{i}{1}.type==2
        fi =  F.clauses{i}{1}.data;
        f = [f;fi(:)];
    else
        error('Only linear element-wise inequalities can be reduced')
    end
end

if ~islinear(F)
    error('Only linear element-wise inequalities can be reduced')
end

B = full(getbase(f));
P = polytope(-B(:,2:end),B(:,1));

x_vars = getvariables(F);
x = recover(x_vars);

H = get(P,'H');
K = get(P,'K');

F = set(H*x < K);
