function F = replace(F,X,W)
%REPLACE        Substitutes variables in an SET object
%
%Z = REPLACE(F,X,W)  Replaces any occurence of the SDPVAR object Y 
%                    in the SDPVAR object X with the double W
%
% Example
%  x = sdpvar(1,1);
%  t = sdpvar(1,1);
%  F = set([1+t;1+x+t] > 0);
%  F = replace(F,x,2) generates F=set([1+t;3+t] > 0)

keep = [];
for i = 1:length(F.clauses)
    F.clauses{i}{1}.data = replace(F.clauses{i}{1}.data,X,W);
    if isempty(F.clauses{i}{1}.data) | isa(F.clauses{i}{1}.data,'double')
        keep(i)=0;
    else
        keep(i)=1;
    end
end
% TODO: 
warning('This code should be fixed for logic constraints. Report this bug...')
F.clauses = {F.clauses{find(keep)}};