function F = logic2cont(x)

% Author Johan Lfberg
% $Id: logic2cont.m,v 1.2 2004/07/09 14:29:38 johanl Exp $

F = set([]);
M = 1e3;
% Go though all clauses
for i = 1:size(x.clauses,1)

    % How many elements in this clause
    n = size( x.clauses{i},2);
    % Are all simple letters?
    all_letters = 1;
    j = 1;
    while all_letters & j<=n
        all_letters = all_letters &  isa(x.clauses{i}{j},'sdpvar');
        j = j + 1;
    end

    if all_letters
        sum_or = 0;
        % Ah, simple constraints, just add them
        for j = 1:n
            sum_or = sum_or + x.clauses{i}{j};
        end

    else
        sum_or = 0;
        delta = binvar(size( x.clauses{i},2),1);
        for j = 1:size( x.clauses{i},2)
            clause_i_j = x.clauses{i}{j};
            if isa(clause_i_j,'constraint')
                delta = binvar(1,1);
                F = F + set(sdpvar(clause_i_j)+M*(1-delta)>0);
                sum_or = sum_or + delta;
            elseif isa(clause_i_j,'sdpvar')
                F = F + set(clause_i_j);
                sum_or = sum_or + clause_i_j;
            end
        end
        
    end
    F = F + set(sum_or>1);
end
