function [w,F,DefinedMonoms] = recdef(pow,F,DefinedMonoms);

% Author Johan Lfberg
% $Id: recdef.m,v 1.1 2005/01/07 13:24:24 johanl Exp $

% Recursively define monomial x(pow(1))*x(pow(2))*x(pow(3))..
% using a set of linear variables and bilinear constraints
switch length(pow)
    case 1
        % Just a linear variable, no constraints needed
        w = recover(pow);
    case 2
        % Quadratic
        w = sdpvar(1,1);
        F = F + set(w  == prod(recover(pow)));
    otherwise
        i = 1;
        found = 0;
        while ~found & i <= length(DefinedMonoms)
            if isequal(pow,DefinedMonoms(i).power)           
                w = recover(DefinedMonoms(i).variable);
                return
            end
            i = i + 1;
        end
        pow1 = pow(1:floor(length(pow)/2));
        pow2 = pow(1+floor(length(pow)/2):end);
        [w1,F,DefinedMonoms] = recdef(pow1,F,DefinedMonoms);
        [w2,F,DefinedMonoms] = recdef(pow2,F,DefinedMonoms);
        w = sdpvar(1,1);
        F = F + set(w == w1*w2);
        DefinedMonoms(end+1).power = pow;
        DefinedMonoms(end).variable = getvariables(w);
end