function dfdx = shadowjacobian(f,x)
% See SDPVAR/jacobian

% Author Johan Lfberg
% $Id: shadowjacobian.m,v 1.1 2004/09/15 08:48:21 johanl Exp $

if nargin==1
    if isa(f,'sdpvar')
        x = recover(depends(f));
    else
        x = 0;
    end
else
    if length(getvariables(x))<length(x)
        error('x should be a vector of scalar independant variables');
    end
end

if isa(f,'double')
    dfdx = zeros(size(f,1),length(x));
end

[n,m]=size(f);

if m>1
   error('Jacobian only defined for column vectors.')
end

if n*m==1
    dfdx = scalar_jacobian(f,x);
    % Argh, fix this (sorts inside scalar_jacobian    
    for i = 1:length(x)
        var(i,1)=getvariables(x(i));
    end
    [i,j]=sort(var);
    dfdx = dfdx(1,j);
    return
    
else
    dfdx = [];
    AllVars = recover(unique([depends(f) getvariables(x)]));
    for i = 1:length(f)
        dfdx = [dfdx;scalar_jacobian(f(i),x,AllVars)];
    end
    % Argh, fix this (sorts inside scalar_jacobian
    for i = 1:length(x)
        var(i,1)=getvariables(x(i));
    end
    [i,j]=sort(var);
    dfdx = dfdx(:,j);
end

function dfdx = scalar_jacobian(f,x,AllVars)

% Aaaaaah, horrible code. FIX!

if isa(f,'double')
    dfdx = zeros(1,length(x));
    return
end

if nargin==2
    AllVars = recover(unique([depends(f) getvariables(x)]));
end

exponent_p = full(exponents(f,AllVars));

coefficients = getbase(f);
coefficients = coefficients(2:end);
if nnz(exponent_p(1,:))==0
    exponent_p=exponent_p(2:end,:);
end

x_variables = getvariables(x);
AllVars_variables = getvariables(AllVars);
dfdx=[];
for k = 1:length(x)
    wrt = find(ismember(AllVars_variables,x_variables(k)));
    deriv = exponent_p;
    deriv(:,wrt) = deriv(:,wrt)-1;
    poly = 0;
    for i = 1:size(exponent_p,1)
        if deriv(i,wrt)~=-1
            temp=coefficients(i)*exponent_p(i,wrt);
            for j = 1:1:size(deriv,2)
                if deriv(i,j)~=0
                    temp=temp*AllVars(j)^deriv(i,j);
                end
            end
            poly = poly + temp;
        end        
    end
    dfdx = [dfdx ; poly];
end
dfdx = dfdx';