function output = callpensdp(interfacedata)

% Author Johan Lfberg
% $Id: callmipsolve.m,v 1.1 2004/06/17 08:40:26 johanl Exp $

% *********************************
% RETRIEVE PROBLEM
% *********************************
options = interfacedata.options;
F_struc = interfacedata.F_struc;
c       = interfacedata.c;
K       = interfacedata.K;
x0      = interfacedata.x0;
Q       = interfacedata.Q;
integer_variables = interfacedata.integer_variables;
binary_variables = interfacedata.binary_variables;

showprogress('Calling MIPSOLVE',options.showprogress);

% *********************************
% CREATE TOMLB PROBLEM
% *********************************
A = -F_struc(:,2:end);
b = F_struc(:,1);
n = length(c);
m = size(F_struc,1);

Prob = miqpAssign(zeros(n),c, A, repmat(-inf,m,1), b, repmat(-inf,n,1), repmat(inf,n,1), x0,integer_variables);

solvertime = clock;
Result = tomrun('mipsolve',Prob,[],2);     % 2=print level
solvertime=etime(clock,solvertime);
x = Result.x_k;

D_struc = [];

problem = 0;
switch Result.ExitFlag
    case 0 
        problem = 0; %OK
    case {2,4}
        problem = 1; % INFEASIBLE
    case 1
        problem =  3; % Iterations
    otherwise
        problem = -1;
end
infostr = yalmiperror(problem,'MIPSOLVE');	

if options.savesolveroutput
	solveroutput.Result = Result;
else
	solveroutput = [];
end

if options.savesolverinput
	solverinput.Prob = Prob;
else
	solverinput = [];
end


% Standard interface 
output.x           = x;
output.problem     = problem;
output.infostr     = infostr;
output.solverinput = solverinput;
output.solveroutput= solveroutput;
output.solvertime  = solvertime;
output.D_struc = D_struc;